package com.loganmagnan.invisibleplayers;

import com.loganmagnan.invisibleplayers.menusystem.PlayerMenuUtil;
import com.loganmagnan.invisibleplayers.runnables.EntityRunnable;
import com.loganmagnan.invisibleplayers.utils.ClassRegistrationUtils;
import com.loganmagnan.invisibleplayers.utils.ColorUtils;
import com.loganmagnan.invisibleplayers.utils.Utils;
import com.loganmagnan.invisibleplayers.utils.command.CommandFramework;
import com.loganmagnan.invisibleplayers.utils.config.FileConfig;
import com.loganmagnan.invisibleplayers.utils.config.file.Config;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import java.util.HashMap;

@Getter
@Setter
public class InvisiblePlayers extends JavaPlugin {

    // Main Class Instance
    @Getter private static InvisiblePlayers instance;

    // Configuration Files
    private Config mainConfig;

    // Managers

    // Menu System
    private HashMap<Player, PlayerMenuUtil> playerMenuUtilMap = new HashMap<>();

    // Command Framework
    private CommandFramework commandFramework = new CommandFramework(this);

    @Override
    public void onEnable() {
        instance = this;

        this.saveDefaultConfig();
        this.mainConfig = new Config("config", this);

        this.getServer().getConsoleSender().sendMessage(Utils.chatBar);
        this.getServer().getConsoleSender().sendMessage(ColorUtils.getMessageType("&dInvisiblePlayers &7- &av" + this.getDescription().getVersion()));
        this.getServer().getConsoleSender().sendMessage(ColorUtils.getMessageType("&7Made by &eLoganM Development"));
        this.getServer().getConsoleSender().sendMessage(Utils.chatBar);
        this.loadCommands();
        this.loadManagers();
        this.loadListeners();
        this.loadRunnables();
    }

    @Override
    public void onDisable() {
        instance = null;
    }

    private void loadCommands() {
        ClassRegistrationUtils.loadCommands("com.loganmagnan.invisibleplayers.commands");
    }

    private void loadManagers() {

    }

    private void loadListeners() {
        ClassRegistrationUtils.loadListeners("com.loganmagnan.invisibleplayers.listeners");
    }

    private void loadRunnables() {
        new EntityRunnable();
    }

    public PlayerMenuUtil getPlayerMenuUtil(Player player) {
        PlayerMenuUtil playerMenuUtil;

        if (playerMenuUtilMap.containsKey(player)) {
            return playerMenuUtilMap.get(player);
        } else {
            playerMenuUtil = new PlayerMenuUtil(player);

            playerMenuUtilMap.put(player, playerMenuUtil);

            return playerMenuUtil;
        }
    }
}
